<template>
  <div style="">
    <b-overlay :show="carregando" rounded="sm">
      <b-card
          title="Caixa eletrônico"
          img-top
          tag="article"
          class="mb-2"
      >
        <b-card-text>
          Notas disponíveis de R$ 100,00; R$ 50,00; R$ 20,00 e R$ 10,00
        </b-card-text>
        <b-input-group size="lg" prepend="$">
          <b-form-input
              :state="valorDisponivel"
              v-model="valor"
              number
              min="1" max="3000"
              :step="1"
              placeholder="Digite o valor do saque">
          </b-form-input>
          <b-form-invalid-feedback id="input-live-feedback">
            Não há notas disponiveis para o valor desejado.
          </b-form-invalid-feedback>
        </b-input-group>

        <div class="mt-3">
          <b-button :disabled="!valor || !valorDisponivel" @click="sacar" class="mr-2">Sacar</b-button>
          <b-button class="mr-2" @click="valor = 0; resultado = {}" variant="danger">Cancelar</b-button>
        </div>
      </b-card>

      <div class="col-md-12">
        <b-card-group deck>
          <b-card
              v-for="item in resultado.notas" :key="item.cedula"
              :title="`R$ ${item.cedula}`"
              :img-src="cedulas[item.cedula]"
              img-alt="Image"
              img-top
              tag="article"
              style="max-width: 20rem;"
              class="mb-2"
          >
            <b-card-text>
              Quantidade: {{ item.quantidade }}
            </b-card-text>

          </b-card>
        </b-card-group>
      </div>
    </b-overlay>
  </div>
</template>

<script>
import api from "@/auth/auth";

export default {
  name: "Caixa",
  data() {
    return {
      valor: 0,
      resultado: {},
      carregando: false,
      cedulas: {
        50: "https://devops-orizon.s3-sa-east-1.amazonaws.com/50.jpg",
        10: "https://devops-orizon.s3-sa-east-1.amazonaws.com/10.jpeg",
        20: "https://devops-orizon.s3-sa-east-1.amazonaws.com/20.jpg",
        100: "https://devops-orizon.s3-sa-east-1.amazonaws.com/100.jpg"
      }
    }
  },
  computed: {
    valorDisponivel() {
      return this.valor > 0 && this.valor % 10 === 0
    }
  },
  methods: {
    async sacar() {
      try {
        this.carregando = true
        const data = await api.get(`api/saque/${this.valor}`)
        this.resultado = data.data
        if (data.data.resto !== 0) {
          this.$notify({
            group: "foo",
            type: "warn",
            title: "Dados invalidos",
            text: "Valor deve ser divisivel de 10"
          });
        }
      } finally {
        this.carregando = false
      }
    }
  }
}
</script>

<style scoped>

</style>